#ifndef _LIGHT_VE_H_
#define _LIGHT_VE_H_

#include "lve_kmod_c.h"
#include "lve-api.h"

asmlinkage long sys_light_ve(uint32_t ve, ve_op op, void *data);

int __init lve_init(void);
int lve_fini(void);

int __init lve_stats_init(void);
void lve_stats_fini(void);

/* lve_resource.c */
int __init lve_res_init(void);
void lve_res_fini(void);

/* lve_lvp.c */
int __init lve_lvp_init(void);
void lve_lvp_fini(void);

/* lve_exec.c */
struct lvp_ve_private;
int __init lvp_exec_init(struct lvp_ve_private *lvp);
void lvp_exec_fini(struct lvp_ve_private *lvp);
int lve_exec_process(struct dentry *dentry, uid_t euid);

int __init lve_exec_init(void);
void lve_exec_fini(void);

/* lve_map.c */
int __init lve_lvp_map_init(void);
void lve_lvp_map_fini(void);

int lve_hooks_init(void);
void lve_hooks_fini(void);

/* lsm/lsm.c */
#if KMOD_LSM == 1
int __init lve_lsm_init(void);
void lve_lsm_fini(void);
#endif

/* lve_sysctl.c */
#ifdef FEAT_SYSCTL
int __init lve_sysctl_init(void);
void lve_sysctl_fini(void);
#else
static inline int lve_sysctl_init(void) { return 0; }
static inline void lve_sysctl_fini(void) { }
#endif

#endif
